import sys
import os

#from time import strftime
from WorkerArgs import WorkerArgs
            
class Collect:
    def run(self, workerArgsList, user, outDir):
        ret = os.system('mkdir -p "%s" ' % (outDir))
        
        if ret != 0:
            print "Error occurred while creating directory " + outDir + "."
            print ret
            sys.exit(1)
            
        #newDir = outDir + "/musician" + "-" + strftime("%Y-%m-%d-%H-%M-%S")
        #ret = os.system('mkdir "%s" ' % (newDir))
	newDir=outDir
        
        if ret != 0:
            print "Error occurred while creating directory " + newDir + "."
            sys.exit(1)
            
        for workerArgs in workerArgsList: 

            dest = user +"@" + workerArgs.host
            port = str(workerArgs.port)
            print "collecting files from " + workerArgs.host + ":" + port + " to directory " + newDir
            os.system('scp "%s:%s" "%s"' % (dest, "KDDDataService-" + port + "/musician.properties", newDir + "/musician-" + workerArgs.host + "-" + port  + ".properties" ))
            os.system('scp "%s:%s" "%s"' % (dest, "KDDDataService-" + port + "/*.log", newDir))

            if os.path.isfile(newDir + "/musician.log"): 
               os.system('mv "%s" "%s"' % (newDir + "/musician.log", newDir + "/musician-" + workerArgs.host + "-" + port  + ".log"))

            if os.path.isfile(newDir + "/results.log"): 
               os.system('mv "%s" "%s"' % (newDir + "/results.log", newDir + "/results-" + workerArgs.host + "-" + port  + ".log"))
        
if __name__ == '__main__' :
    if len(sys.argv) < 4:
        print "Usage: Collector.py commandFile userName outDir"
        sys.exit(1)
    
    workerArgsList = []
    f = open(sys.argv[1])
    user = sys.argv[2]
    outDir = sys.argv[3]
    
    try:
        for line in f:
            workerArgs = WorkerArgs()
            line = line.strip()
            if line == "" or line.startswith("#"):
                continue
            tokens = line.split(',')

            if len(tokens) != 3:
               print "skipping bad command line:" + line
               continue

            workerArgs.setHost(tokens[0])
            workerArgs.setPort(int(tokens[1]));
            workerArgs.setCommand(tokens[2])
            workerArgsList.append(workerArgs)
    finally:
        f.close()

    if len(workerArgsList) == 0:
        print "command file does not contain any commands"
        sys.exit(1)

    collect = Collect()
    collect.run(workerArgsList, user, outDir)
