import sys
import os

class GenReport:
    def run(self, jarDir, logDir, friendlyName):
        newLogDir = os.path.abspath(logDir)
        ret = os.system('cd  "%s";java -jar GenReports.jar "%s" "%s"' % (jarDir, newLogDir, friendlyName))
        if ret != 0:
            print "Error occurred while generating report ..."
            sys.exit(1)
        
if __name__ == '__main__' :
    if len(sys.argv) < 4:
        print "Usage: GenReport.py GenReportDir logDir friendlyName"
        sys.exit(1)
    
    print "Generating report ..."
    jarDir = sys.argv[1]
    logDir = sys.argv[2]
    friendlyName = sys.argv[3]
    collect = GenReport()
    collect.run(jarDir, logDir, friendlyName)
    print "Done generating the report."
