import subprocess
import sys

from WorkerArgs import WorkerArgs

class Kill:
    def setWorkArgsList(self, workerArgsList):
        self.workerArgsList = workerArgsList
        
    def run(self):
        hosts = set()
        
        for workerArgs in workerArgsList: 
            hosts.add(workerArgs.host)
            
        for host in hosts: 
            dest = user +"@" + host
            ########
            # Careful ...
            #subprocess.call(["ssh", dest, "killall java"])
            #
            subprocess.call(["ssh", dest, "ps ax | grep TestKDDDataService.jar | grep -v grep | awk '{print $1}' | xargs kill >& /dev/null"])
        
if __name__ == '__main__' :
    if len(sys.argv) < 3:
        print "Usage: KillAll.py commandFile userName"
        sys.exit(1)
        
    workerArgsList = []
    f = open(sys.argv[1])
    user = sys.argv[2]
    
    try:
        for line in f:
            workerArgs = WorkerArgs()
            line = line.strip()
            if line == "" or line.startswith("#"):
                continue
            tokens = line.split(',')

            if len(tokens) != 3:
               print "skipping bad command line:" + line
               continue

            workerArgs.setHost(tokens[0])
            workerArgs.setPort(int(tokens[1]));
            workerArgs.setCommand(tokens[2])
            workerArgsList.append(workerArgs)
    finally:
        f.close()

    if len(workerArgsList) == 0:
        print "command file does not contain any commands"
        sys.exit(1)

    kill = Kill()
    kill.setWorkArgsList(workerArgsList)
    kill.run()
